<template>
<div class="main_app">
  <div class="header">
    <h1><img class="logo" src="/csdc-logo.svg" /> CSDC Download Helper</h1>
    <ul class="nav-list">
      <li>
        <a href="#" @click="navTo('https://noirlab.edu')">NOIRLab</a>
      </li>
      <li>
        <a href="#" @click="navTo('https://astroarchive.noirlab.edu/portal/search/')">Astroarchive Search</a>
      </li>
    </ul>
  </div>

  <section class="actions">
    <button v-if="files.length < 1" @click="fileSelectorTab">Load Manifest</button>
    <button v-if="files.length > 0" @click="clearManifest">Clear Manifest <span v-if="pauseOption || resumeOption">& Cancel Downloads</span></button>
    <button @click="startDownload" v-if="files.length > 0 && !pauseOption && !resumeOption ">Start Download</button>
    <button @click="pauseDownload" v-if="pauseOption">Pause Download</button>
    <button @click="resumeDownload" v-if="resumeOption">Resume Download</button>
  </section>

  <section class="messages">
    <div class="error" v-if="errMsg !== null">{{ errMsg }}</div>
    <div class="notice" v-if="noticeMsg !== null">{{ noticeMsg }}</div>
  </section>

  <section class="files">
  <h4>{{ totalFiles }} Files in last manifest</h4>
    <ul v-if="files.length > 0">
      <li v-for="(file, idx) in files" :key="idx">{{ file.filename }}</li>
    </ul>
    <div v-if="files.length < 1">
      <h3 class="no-manifest">No manifest found.</h3>
      <p>Load a manifest file from disk or create a new one using using the archive search portal and selecting files to download.</p>
      <ul>
        <li><a href="#" @click="navTo('https://astroarchive.noirlab.edu/portal/search/')">Astroarchive</a></li>
      </ul>
    </div>
  </section>
</div>
</template>

<script>

var client;


/* eslint-disable */
export default {
  name: 'popupView',
  data () {
    return {
      completedCount: 0,
      noticeMsg: null,
      errMsg: null,
      pauseOption: false,
      resumeOption: false,
      totalFiles: 0,
      files: [],
    }
  },
  created() {
    if(navigator.userAgent.includes('Chrome')) {
      client = chrome;
    }else{
      client = browser;
    }

    client.runtime.onMessage.addListener((request) => {
      if(request.action && request.action === 'allDone'){
        this.noticeMsg = "Downloading finished";
        this.pauseOption = false;
      }
      if(request.action && request.action === "startDownload"){
        this.pauseOption = true;
      }
    });

    client.storage.local.get('canPause').then( (res) => {
      this.pauseOption = res.canPause;
    });

    client.storage.local.get('canResume').then( (res) => {
      this.resumeOption = res.canResume;
    });

    client.storage.local.get('files').then((res) => {
      if(Object.keys(res).length > 0){
        this.files = JSON.parse(res.files);
      }
    });

    client.storage.local.get('fileCount').then((res) => {
      if(res.fileCount){
        this.totalFiles = res.fileCount.totalFiles;
        this.completedCount = res.fileCount.completedCount;
      }
    });
  },

  methods: {
    fileSelectorTab () {
      client.tabs.create({url: '/file_selector.html'})
    },
    pauseDownload () {
      client.runtime.sendMessage({'action': 'pause'});
      this.pauseOption = false;
      this.resumeOption = true;
    },
    resumeDownload () {
      client.runtime.sendMessage({'action': 'resume'});
      this.resumeOption = false;
      this.pauseOption = true;
    },
    clearManifest () {
      client.runtime.sendMessage({action: 'clearManifest'});
      this.files = [];
      this.errMsg = null;
      this.totalFiles = this.files.length;
      this.completedCount = 0;
      this.noticeMsg = "Manifest cleared";
      this.pauseOption = false;
      this.resumeOption = false;
    },
    startDownload () {
      this.pauseOption = true;
      client.runtime.sendMessage({action: 'startDownload'});
    },
    navTo (url) {
      console.log(url);
      open(url);
    },
  }
}

</script>

<style>
@import '../assets/main.css';
</style>
